------------------------------------------------------------------------------------------------------------------------------------------------------
--                                            Captulo 05 Laboratrio Dados Agrupados com Funes de Grupo                                          --
--                                               Treinamento para certificao Fundamentals SQL Oracle                                              --
--                                           Pedro F. Carvalho - DBA / Analista de Sistemas / Desenvolvedor                                         --
--                                         Site : www.pedrofcarvalho.com.br   E-mail : contato@pedrofcarvalho.com.br                                --
------------------------------------------------------------------------------------------------------------------------------------------------------

/* Exerccio 01
Encontre o mais alto, mais baixo, soma e salrio mdio de todos os funcionrios. Rotular as colunas
Mximo, Mnimo, Soma e Mdia, respectivamente. Arredonde seus resultados para o
Nmero inteiro mais prximo. 
*/

select round(max(salary),0) "Maximo",
       round(min(salary),0) "Minimo",
       round(sum(salary),0) "Soma",
       round(avg(salary),0) "Mdia"
from employees;

/* Exerccio 02
Modifique a consulta acima para exibir o mnimo, mximo, soma, e salrio mdio para cada tipo de trabalho. 
*/

select job_id, 
       round(max(salary),0) "Maximo",
       round(min(salary),0) "Minimo",
       round(sum(salary),0) "Soma",
       round(avg(salary),0) "Mdia"
from employees
group by job_id;


/* Exerccio 03
Escreva uma consulta para exibir o nmero de pessoas com o mesmo trabalho.
*/

select job_id, count(*)
from employees
group by job_id;

/* Exerccio 04
Generalize a consulta para que o usurio no departamento de RH seja solicitado para um cargo.
Insira IT_PROG quando solicitado e clique em OK.
*/

select job_id, count(*)
from employees
where job_id = '&job_title'
group by job_id;

/* Exerccio 05
Determine o nmero de gerentes sem list-los. Rotular a coluna Nmero De Gerentes.
Dica: Use a coluna MANAGER_ID para determinar o nmero de gerentes.

Encontre a diferena entre os salrios mais altos e mais baixos. Rotular a coluna
DIFERENA.
*/

select count(distinct manager_id) "Numero de Gerentes"
from employees;

select * from employees;

select max(salary) - min(salary) DIFERENCA
from employees;


/* Exerccio 06
Criar um relatrio para exibir o nmero do gerente eo salrio do mais baixo-pago
empregado para esse gerente. Exclua qualquer pessoa cujo gerente no seja conhecido. Excluir
Qualquer grupo onde o salrio mnimo  de US $ 6.000 ou menos. Classificar a sada em ordem decrescente
Ordem do salrio.
*/

select manager_id, min(salary)
from employees
where manager_id is not null
group by manager_id
having min(salary) < 60000
order by min(salary) desc;

-- Errata olha exerccio anterior.


/* Exerccio 07
Crie uma consulta que exiba o nmero total de funcionrios e, desse total, a
Nmero de funcionrios contratados em 1995, 1996, 1997 e 1998. Criar
Cabealhos das colunas.
*/

select count(*) TOTAL,
      sum(decode(to_char(hire_date, 'YYYY'),2001,1,0)) "2001",
      sum(decode(to_char(hire_date, 'YYYY'),2002,1,0)) "2002",
      sum(decode(to_char(hire_date, 'YYYY'),2003,1,0)) "2003",
      sum(decode(to_char(hire_date, 'YYYY'),2004,1,0)) "2004"
from employees;

select * from employees;


/* Exerccio 08
Criar uma consulta de matriz para exibir o trabalho, o salrio para esse trabalho com base no
Nmero de departamento, eo salrio total para esse trabalho, para os departamentos 20, 50, 80 e
90, dando a cada coluna um cabealho apropriado.
*/

select job_id "JOB",
       sum(decode(department_id, 20, salary)) "20",
       sum(decode(department_id, 50, salary)) "50",
       sum(decode(department_id, 80, salary)) "80",
       sum(decode(department_id, 90, salary)) "90"
from employees
group by job_id;

  
-- Passos de estudos
-- 1 - Assistir a video aula somente observando 1x
-- 2 - Assistir a video aula agora fazendo os scritps 1x
-- 3 - Assistir a video aula de laboratrio 1x
-- 4 - Assistir a video aula de laboratrio fazendo os scritps 1x
-- 5 - Realizar o simulado online
       
-- Abraos e bons estudos !







